JUCE: ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

JUCE

Public Types | Public Member Functions | List of all members
ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

Holds a list of objects derived from ReferenceCountedObject, or which implement basic reference-count handling methods. More...

## Public Types
using | ObjectClassPtr = ReferenceCountedObjectPtr< ObjectClass >
using | ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType
| Returns the type of scoped lock to use for locking this array. More...

## Public Member Functions
| ReferenceCountedArray ()=default
| Creates an empty array. More...
| ReferenceCountedArray (const ReferenceCountedArray &other) noexcept
| Creates a copy of another array. More...
| ReferenceCountedArray (ReferenceCountedArray &&other) noexcept
| Moves from another array. More...
template<class OtherObjectClass , class OtherCriticalSection >
| ReferenceCountedArray (const ReferenceCountedArray< OtherObjectClass, OtherCriticalSection > &other) noexcept
| Creates a copy of another array. More...
ReferenceCountedArray & | operator= (const ReferenceCountedArray &other) noexcept
| Copies another array into this one. More...
template<class OtherObjectClass >
ReferenceCountedArray & | operator= (const ReferenceCountedArray< OtherObjectClass, TypeOfCriticalSectionToUse > &other) noexcept
| Copies another array into this one. More...
ReferenceCountedArray & | operator= (ReferenceCountedArray &&other) noexcept
| Moves from another array. More...
| ~ReferenceCountedArray ()
| Destructor. More...
void | clear ()
| Removes all objects from the array. More...
void | clearQuick ()
| Removes all objects from the array without freeing the array's allocated storage. More...
int | size () const noexcept
| Returns the current number of objects in the array. More...
bool | isEmpty () const noexcept
| Returns true if the array is empty, false otherwise. More...
ObjectClassPtr | operator[] (int index) const noexcept
| Returns a pointer to the object at this index in the array. More...
ObjectClassPtr | getUnchecked (int index) const noexcept
| Returns a pointer to the object at this index in the array, without checking whether the index is in-range. More...
ObjectClass * | getObjectPointer (int index) const noexcept
| Returns a raw pointer to the object at this index in the array. More...
ObjectClass * | getObjectPointerUnchecked (int index) const noexcept
| Returns a raw pointer to the object at this index in the array, without checking whether the index is in-range. More...
ObjectClassPtr | getFirst () const noexcept
| Returns a pointer to the first object in the array. More...
ObjectClassPtr | getLast () const noexcept
| Returns a pointer to the last object in the array. More...
ObjectClass ** | getRawDataPointer () const noexcept
| Returns a pointer to the actual array data. More...
ObjectClass ** | begin () noexcept
| Returns a pointer to the first element in the array. More...
ObjectClass *const * | begin () const noexcept
| Returns a pointer to the first element in the array. More...
ObjectClass ** | end () noexcept
| Returns a pointer to the element which follows the last element in the array. More...
ObjectClass *const * | end () const noexcept
| Returns a pointer to the element which follows the last element in the array. More...
ObjectClass ** | data () noexcept
| Returns a pointer to the first element in the array. More...
ObjectClass *const * | data () const noexcept
| Returns a pointer to the first element in the array. More...
int | indexOf (const ObjectClass *objectToLookFor) const noexcept
| Finds the index of the first occurrence of an object in the array. More...
int | indexOf (const ObjectClassPtr &objectToLookFor) const noexcept
| Finds the index of the first occurrence of an object in the array. More...
bool | contains (const ObjectClass *objectToLookFor) const noexcept
| Returns true if the array contains a specified object. More...
bool | contains (const ObjectClassPtr &objectToLookFor) const noexcept
| Returns true if the array contains a specified object. More...
ObjectClass * | add (ObjectClass *newObject)
| Appends a new object to the end of the array. More...
ObjectClass * | add (const ObjectClassPtr &newObject)
| Appends a new object to the end of the array. More...
ObjectClass * | insert (int indexToInsertAt, ObjectClass *newObject)
| Inserts a new object into the array at the given index. More...
ObjectClass * | insert (int indexToInsertAt, const ObjectClassPtr &newObject)
| Inserts a new object into the array at the given index. More...
bool | addIfNotAlreadyThere (ObjectClass *newObject)
| Appends a new object at the end of the array as long as the array doesn't already contain it. More...
bool | addIfNotAlreadyThere (const ObjectClassPtr &newObject)
| Appends a new object at the end of the array as long as the array doesn't already contain it. More...
void | set (int indexToChange, ObjectClass *newObject)
| Replaces an object in the array with a different one. More...
void | set (int indexToChange, const ObjectClassPtr &newObject)
| Replaces an object in the array with a different one. More...
void | addArray (const ReferenceCountedArray &arrayToAddFrom, int startIndex=0, int numElementsToAdd=-1) noexcept
| Adds elements from another array to the end of this array. More...
template<class ElementComparator >
int | addSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
| Inserts a new object into the array assuming that the array is sorted. More...
template<class ElementComparator >
void | addOrReplaceSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
| Inserts or replaces an object in the array, assuming it is sorted. More...
template<class ElementComparator >
int | indexOfSorted (ElementComparator &comparator, const ObjectClass *objectToLookFor) const noexcept
| Finds the index of an object in the array, assuming that the array is sorted. More...
void | remove (int indexToRemove)
| Removes an object from the array. More...
ObjectClassPtr | removeAndReturn (int indexToRemove)
| Removes and returns an object from the array. More...
void | removeObject (ObjectClass *objectToRemove)
| Removes the first occurrence of a specified object from the array. More...
void | removeObject (const ObjectClassPtr &objectToRemove)
| Removes the first occurrence of a specified object from the array. More...
void | removeRange (int startIndex, int numberToRemove)
| Removes a range of objects from the array. More...
void | removeLast (int howManyToRemove=1)
| Removes the last n objects from the array. More...
void | swap (int index1, int index2) noexcept
| Swaps a pair of objects in the array. More...
void | move (int currentIndex, int newIndex) noexcept
| Moves one of the objects to a different position. More...
template<class OtherArrayType >
void | swapWith (OtherArrayType &otherArray) noexcept
| This swaps the contents of this array with those of another array. More...
bool | operator== (const ReferenceCountedArray &other) const noexcept
| Compares this array to another one. More...
bool | operator!= (const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > &other) const noexcept
| Compares this array to another one. More...
template<class ElementComparator >
void | sort (ElementComparator &comparator, bool retainOrderOfEquivalentItems=false) noexcept
| Sorts the elements in the array. More...
void | minimiseStorageOverheads () noexcept
| Reduces the amount of storage being used by the array. More...
void | ensureStorageAllocated (const int minNumElements)
| Increases the array's internal storage to hold a minimum number of elements. More...
const TypeOfCriticalSectionToUse & | getLock () const noexcept
| Returns the CriticalSection that locks this array. More...

## Detailed Description

### template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
class ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >

Holds a list of objects derived from ReferenceCountedObject, or which implement basic reference-count handling methods.

The template parameter specifies the class of the object you want to point to - the easiest way to make a class reference-countable is to simply make it inherit from ReferenceCountedObject or SingleThreadedReferenceCountedObject, but if you need to, you can roll your own reference-countable class by implementing a set of methods called incReferenceCount(), decReferenceCount(), and decReferenceCountWithoutDeleting(). See ReferenceCountedObject for examples of how these methods should behave.

A ReferenceCountedArray holds objects derived from ReferenceCountedObject, and takes care of incrementing and decrementing their ref counts when they are added and removed from the array.

To make all the array's methods thread-safe, pass in "CriticalSection" as the templated TypeOfCriticalSectionToUse parameter, instead of the default DummyCriticalSection.

See also
  Array, OwnedArray, StringArray

## Member Typedef Documentation

## ◆ ObjectClassPtr

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

using ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ObjectClassPtr = ReferenceCountedObjectPtr<ObjectClass>

## ◆ ScopedLockType

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

using ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

Returns the type of scoped lock to use for locking this array.

## Constructor & Destructor Documentation

## ◆ ReferenceCountedArray() [1/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( |  | ) |
| default

Creates an empty array.

See also
  ReferenceCountedObject, Array, OwnedArray

## ◆ ReferenceCountedArray() [2/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) |
| noexcept

Creates a copy of another array.

## ◆ ReferenceCountedArray() [3/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| noexcept

Moves from another array.

## ◆ ReferenceCountedArray() [4/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass , class OtherCriticalSection >

ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | const ReferenceCountedArray< OtherObjectClass, OtherCriticalSection > & | other | ) |
| noexcept

Creates a copy of another array.

## ◆ ~ReferenceCountedArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::~ReferenceCountedArray | ( |  | ) |

Destructor.

Any objects in the array will be released, and may be deleted if not referenced from elsewhere.

## Member Function Documentation

## ◆ operator=() [1/3]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray& ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) |
| noexcept

Copies another array into this one.

Any existing objects in this array will first be released.

## ◆ operator=() [2/3]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass >

ReferenceCountedArray& ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | const ReferenceCountedArray< OtherObjectClass, TypeOfCriticalSectionToUse > & | other | ) |
| noexcept

Copies another array into this one.

Any existing objects in this array will first be released.

## ◆ operator=() [3/3]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray& ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| noexcept

Moves from another array.

## ◆ clear()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear | ( |  | ) |

Removes all objects from the array.

Any objects in the array whose reference counts drop to zero will be deleted.

## ◆ clearQuick()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick | ( |  | ) |

Removes all objects from the array without freeing the array's allocated storage.

Any objects in the array that whose reference counts drop to zero will be deleted.

See also
  clear

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::clear().

## ◆ size()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::size | ( |  | ) | const
| noexcept

Returns the current number of objects in the array.

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::isEmpty().

## ◆ isEmpty()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty | ( |  | ) | const
| noexcept

Returns true if the array is empty, false otherwise.

## ◆ operator[]()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[] | ( | int | index | ) | const
| noexcept

Returns a pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

## ◆ getUnchecked()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked | ( | int | index | ) | const
| noexcept

Returns a pointer to the object at this index in the array, without checking whether the index is in-range.

This is a faster and less safe version of operator[] which doesn't check the index passed in, so it can be used when you're sure the index is always going to be legal.

## ◆ getObjectPointer()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointer | ( | int | index | ) | const
| noexcept

Returns a raw pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::operator[]().

## ◆ getObjectPointerUnchecked()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointerUnchecked | ( | int | index | ) | const
| noexcept

Returns a raw pointer to the object at this index in the array, without checking whether the index is in-range.

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::getUnchecked().

## ◆ getFirst()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst | ( |  | ) | const
| noexcept

Returns a pointer to the first object in the array.

This will return a null pointer if the array's empty.

See also
  getLast

## ◆ getLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast | ( |  | ) | const
| noexcept

Returns a pointer to the last object in the array.

This will return a null pointer if the array's empty.

See also
  getFirst

## ◆ getRawDataPointer()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass** ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getRawDataPointer | ( |  | ) | const
| noexcept

Returns a pointer to the actual array data.

This pointer will only be valid until the next time a non-const method is called on the array.

## ◆ begin() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass** ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) |
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::data().

## ◆ begin() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* const* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) | const
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## ◆ end() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass** ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) |
| noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## ◆ end() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* const* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) | const
| noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## ◆ data() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass** ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) |
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

## ◆ data() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* const* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) | const
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

## ◆ indexOf() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClass * | objectToLookFor | ) | const
| noexcept

Finds the index of the first occurrence of an object in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::removeObject().

## ◆ indexOf() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClassPtr & | objectToLookFor | ) | const
| noexcept

Finds the index of the first occurrence of an object in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::indexOf().

## ◆ contains() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClass * | objectToLookFor | ) | const
| noexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::addIfNotAlreadyThere().

## ◆ contains() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClassPtr & | objectToLookFor | ) | const
| noexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::contains().

## ◆ add() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | ObjectClass * | newObject | ) |

Appends a new object to the end of the array.

This will increase the new object's reference count.

Parameters

  newObject | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addArray

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::addIfNotAlreadyThere().

## ◆ add() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | const ObjectClassPtr & | newObject | ) |

Appends a new object to the end of the array.

This will increase the new object's reference count.

Parameters

  newObject | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addArray

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::add().

## ◆ insert() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | ObjectClass * | newObject
| ) |  |

Inserts a new object into the array at the given index.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

This will increase the new object's reference count.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

See also
  add, addSorted, addIfNotAlreadyThere, set

## ◆ insert() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass* ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | const ObjectClassPtr & | newObject
| ) |  |

Inserts a new object into the array at the given index.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

This will increase the new object's reference count.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

See also
  add, addSorted, addIfNotAlreadyThere, set

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::insert().

## ◆ addIfNotAlreadyThere() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere | ( | ObjectClass * | newObject | ) |

Appends a new object at the end of the array as long as the array doesn't already contain it.

If the array already contains a matching object, nothing will be done.

Parameters

  newObject | the new object to add to the array

Returns
  true if the object has been added, false otherwise

Referenced by BlockTopology::getDirectlyConnectedBlocks().

## ◆ addIfNotAlreadyThere() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere | ( | const ObjectClassPtr & | newObject | ) |

Appends a new object at the end of the array as long as the array doesn't already contain it.

If the array already contains a matching object, nothing will be done.

Parameters

  newObject | the new object to add to the array

Returns
  true if the object has been added, false otherwise

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::addIfNotAlreadyThere().

## ◆ set() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | ObjectClass * | newObject
| ) |  |

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

The object being added has its reference count increased, and if it's replacing another object, then that one has its reference count decreased, and may be deleted.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.

See also
  add, insert, remove

## ◆ set() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | const ObjectClassPtr & | newObject
| ) |  |

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

The object being added has its reference count increased, and if it's replacing another object, then that one has its reference count decreased, and may be deleted.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.

See also
  add, insert, remove

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::set().

## ◆ addArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | arrayToAddFrom,
|  | int | startIndex = `0`,
|  | int | numElementsToAdd = `-1`
| ) |  |
| noexcept

Adds elements from another array to the end of this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

## ◆ addSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

int ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted | ( | ElementComparator & | comparator,
|  | ObjectClass * | newObject
| ) |  |
| noexcept

Inserts a new object into the array assuming that the array is sorted.

This will use a comparator to find the position at which the new object should go. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator object to use to compare the elements - see the sort() method for details about this object's form
  newObject | the new object to insert to the array

Returns
  the index at which the new object was added

See also
  add, sort

## ◆ addOrReplaceSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addOrReplaceSorted | ( | ElementComparator & | comparator,
|  | ObjectClass * | newObject
| ) |  |
| noexcept

Inserts or replaces an object in the array, assuming it is sorted.

This is similar to addSorted, but if a matching element already exists, then it will be replaced by the new one, rather than the new one being added as well.

## ◆ indexOfSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

int ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOfSorted | ( | ElementComparator & | comparator,
|  | const ObjectClass * | objectToLookFor
| ) |  | const
| noexcept

Finds the index of an object in the array, assuming that the array is sorted.

This will use a comparator to do a binary-chop to find the index of the given element, if it exists. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator to use to compare the elements - see the sort() method for details about the form this object should take
  objectToLookFor | the object to search for

Returns
  the index of the element, or -1 if it's not found

See also
  addSorted, sort

## ◆ remove()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove | ( | int | indexToRemove | ) |

Removes an object from the array.

This will remove the object at a given index and move back all the subsequent objects to close the gap.

If the index passed in is out-of-range, nothing will happen.

The object that is removed will have its reference count decreased, and may be deleted if not referenced from elsewhere.

Parameters

  indexToRemove | the index of the element to remove

See also
  removeObject, removeRange

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::removeLast(), and ReferenceCountedArray< AudioProcessorGraph::Node >::removeObject().

## ◆ removeAndReturn()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn | ( | int | indexToRemove | ) |

Removes and returns an object from the array.

This will remove the object at a given index and return it, moving back all the subsequent objects to close the gap. If the index passed in is out-of-range, nothing will happen and a null pointer will be returned.

Parameters

  indexToRemove | the index of the element to remove

See also
  remove, removeObject, removeRange

## ◆ removeObject() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | ObjectClass * | objectToRemove | ) |

Removes the first occurrence of a specified object from the array.

If the item isn't found, no action is taken. If it is found, it is removed and has its reference count decreased.

Parameters

  objectToRemove | the object to try to remove

See also
  remove, removeRange

## ◆ removeObject() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | const ObjectClassPtr & | objectToRemove | ) |

Removes the first occurrence of a specified object from the array.

If the item isn't found, no action is taken. If it is found, it is removed and has its reference count decreased.

Parameters

  objectToRemove | the object to try to remove

See also
  remove, removeRange

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::removeObject().

## ◆ removeRange()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange | ( | int | startIndex,
|  | int | numberToRemove
| ) |  |

Removes a range of objects from the array.

This will remove a set of objects, starting from the given index, and move any subsequent elements down to close the gap.

If the range extends beyond the bounds of the array, it will be safely clipped to the size of the array.

The objects that are removed will have their reference counts decreased, and may be deleted if not referenced from elsewhere.

Parameters

  startIndex | the index of the first object to remove
  numberToRemove | how many objects should be removed

See also
  remove, removeObject

## ◆ removeLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast | ( | int | howManyToRemove = `1` | ) |

Removes the last n objects from the array.

The objects that are removed will have their reference counts decreased, and may be deleted if not referenced from elsewhere.

Parameters

  howManyToRemove | how many objects to remove from the end of the array

See also
  remove, removeObject, removeRange

## ◆ swap()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap | ( | int | index1,
|  | int | index2
| ) |  |
| noexcept

Swaps a pair of objects in the array.

If either of the indexes passed in is out-of-range, nothing will happen, otherwise the two objects at these positions will be exchanged.

## ◆ move()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::move | ( | int | currentIndex,
|  | int | newIndex
| ) |  |
| noexcept

Moves one of the objects to a different position.

This will move the object to a specified index, shuffling along any intervening elements as required.

So for example, if you have the array { 0, 1, 2, 3, 4, 5 } then calling move (2, 4) would result in { 0, 1, 3, 4, 2, 5 }.

Parameters

  currentIndex | the index of the object to be moved. If this isn't a valid index, then nothing will be done
  newIndex | the index at which you'd like this object to end up. If this is less than zero, it will be moved to the end of the array

## ◆ swapWith()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith | ( | OtherArrayType & | otherArray | ) |
| noexcept

This swaps the contents of this array with those of another array.

If you need to exchange two arrays, this is vastly quicker than using copy-by-value because it just swaps their internal pointers.

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::operator=().

## ◆ operator==()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator== | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) | const
| noexcept

Compares this array to another one.

Returns
  true only if the other array contains the same objects in the same order

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::operator!=().

## ◆ operator!=()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator!= | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) | const
| noexcept

Compares this array to another one.

See also
  operator==

## ◆ sort()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort | ( | ElementComparator & | comparator,
|  | bool | retainOrderOfEquivalentItems = `false`
| ) |  |
| noexcept

Sorts the elements in the array.

This will use a comparator object to sort the elements into order. The object passed must have a method of the form:

int compareElements (ElementType first, ElementType second);

..and this method must return:

- a value of < 0 if the first comes before the second
- a value of 0 if the two objects are equivalent
- a value of > 0 if the second comes before the first

To improve performance, the compareElements() method can be declared as static or const.

Parameters

  comparator | the comparator to use for comparing elements.
  retainOrderOfEquivalentItems | if this is true, then items which the comparator says are equivalent will be kept in the order in which they currently appear in the array. This is slower to perform, but may be important in some cases. If it's false, a faster algorithm is used, but equivalent elements may be rearranged.

See also
  sortArray

## ◆ minimiseStorageOverheads()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads | ( |  | ) |
| noexcept

Reduces the amount of storage being used by the array.

Arrays typically allocate slightly more storage than they need, and after removing elements, they may have quite a lot of unused space allocated. This method will reduce the amount of allocated storage to a minimum.

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::remove(), ReferenceCountedArray< AudioProcessorGraph::Node >::removeAndReturn(), and ReferenceCountedArray< AudioProcessorGraph::Node >::removeRange().

## ◆ ensureStorageAllocated()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated | ( | const int | minNumElements | ) |

Increases the array's internal storage to hold a minimum number of elements.

Calling this before adding a large known number of elements means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

## ◆ getLock()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

const TypeOfCriticalSectionToUse& ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock | ( |  | ) | const
| noexcept

Returns the CriticalSection that locks this array.

To lock, you can call getLock().enter() and getLock().exit(), or preferably use an object of ScopedLockType as an RAII lock for it.

Referenced by ReferenceCountedArray< AudioProcessorGraph::Node >::add(), ReferenceCountedArray< AudioProcessorGraph::Node >::addArray(), ReferenceCountedArray< AudioProcessorGraph::Node >::addIfNotAlreadyThere(), ReferenceCountedArray< AudioProcessorGraph::Node >::addOrReplaceSorted(), ReferenceCountedArray< AudioProcessorGraph::Node >::addSorted(), ReferenceCountedArray< AudioProcessorGraph::Node >::clear(), ReferenceCountedArray< AudioProcessorGraph::Node >::clearQuick(), ReferenceCountedArray< AudioProcessorGraph::Node >::contains(), ReferenceCountedArray< AudioProcessorGraph::Node >::ensureStorageAllocated(), ReferenceCountedArray< AudioProcessorGraph::Node >::getFirst(), ReferenceCountedArray< AudioProcessorGraph::Node >::getLast(), ReferenceCountedArray< AudioProcessorGraph::Node >::getObjectPointer(), ReferenceCountedArray< AudioProcessorGraph::Node >::getObjectPointerUnchecked(), ReferenceCountedArray< AudioProcessorGraph::Node >::indexOf(), ReferenceCountedArray< AudioProcessorGraph::Node >::indexOfSorted(), ReferenceCountedArray< AudioProcessorGraph::Node >::minimiseStorageOverheads(), ReferenceCountedArray< AudioProcessorGraph::Node >::move(), ReferenceCountedArray< AudioProcessorGraph::Node >::operator==(), ReferenceCountedArray< AudioProcessorGraph::Node >::remove(), ReferenceCountedArray< AudioProcessorGraph::Node >::removeAndReturn(), ReferenceCountedArray< AudioProcessorGraph::Node >::removeLast(), ReferenceCountedArray< AudioProcessorGraph::Node >::removeObject(), ReferenceCountedArray< AudioProcessorGraph::Node >::removeRange(), ReferenceCountedArray< AudioProcessorGraph::Node >::set(), ReferenceCountedArray< AudioProcessorGraph::Node >::sort(), ReferenceCountedArray< AudioProcessorGraph::Node >::swap(), and ReferenceCountedArray< AudioProcessorGraph::Node >::swapWith().

The documentation for this class was generated from the following file:

- juce_ReferenceCountedArray.h